CDECK  ID>, HWHGB1.
*CMZ :-        -02/04/01  12.11.55  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWHGB1(ISM,IOPT,IDBOZ,FJAC,MBOS2,MMAX,MMIN)
C-----------------------------------------------------------------------
C     Subroutine to select gauge boson mass for HWHGBP
C     ISM=1 select according to Breit-Wigner for IDBOZ
C     ISM=2 select according to power law  for IDBOZ
C     IOPT=1 return the function at MBOS2
C     IOPT=2 calculate MBOS2
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      INTEGER IDBOZ,ISM,IOPT
      DOUBLE PRECISION MBOZ,FJAC,GBOZ,GMBOZ,MPOW,MMIN,
     &     MBOS2,A1,A2,A01,A02,RPOW,QPOW,HWRGEN,MMAX,EMSQ
      EXTERNAL HWRGEN
C--set the boson mass
      IF(IDBOZ.EQ.198.OR.IDBOZ.EQ.199) THEN
        MBOZ = RMASS(198)
        GBOZ = GAMW
      ELSEIF(IDBOZ.EQ.200) THEN
        MBOZ = RMASS(200)
        GBOZ = GAMZ
      ELSE
        CALL HWWARN('HWHGB1',500)
      ENDIF
      EMSQ=MBOZ**2
      GMBOZ=MBOZ*GBOZ
C--smooth a Breit-Wigner only
      IF(ISM.EQ.1) THEN
        A02   = ATAN((MMIN-EMSQ)/GMBOZ)
        A2    = ATAN((MMAX-EMSQ)/GMBOZ)-A02
        IF(IOPT.EQ.1) THEN
          FJAC = GMBOZ/((MBOS2-EMSQ)**2+GMBOZ**2)/A2
        ELSE
          MBOS2 = EMSQ+GMBOZ*TAN(A02+A2*HWRGEN(1))
          FJAC  = A2*((MBOS2-EMSQ)**2+GMBOZ**2)/GMBOZ
        ENDIF
C--smooth a powerlaw only
      ELSEIF(ISM.EQ.2) THEN
        IF(EMPOW.EQ.TWO) THEN
          A01   = LOG(MMIN)
          A1    = LOG(MMAX)-A01
          IF(IOPT.EQ.1) THEN
            FJAC = ONE/MBOS2/A1
          ELSE
            MBOS2 = EXP(A01+A1*HWRGEN(2))
            FJAC  = A1*MBOS2
          ENDIF
        ELSE
          MPOW = -EMPOW/TWO
          QPOW =  ONE+MPOW
          RPOW =  ONE/QPOW
          A01  =  MMIN**QPOW
          A1   = (MMAX**QPOW-A01)
          IF(IOPT.EQ.1) THEN
            FJAC = QPOW*MBOS2**MPOW/A1
          ELSE
            MBOS2 = (A01+A1*HWRGEN(2))**RPOW
            FJAC  = A1*RPOW/MBOS2**MPOW
          ENDIF
        ENDIF
      ELSE
        CALL HWWARN('HWHGB1',501)
      ENDIF
      END
