CDECK  ID>, HWHGBS.
*CMZ :-        -02/04/01  12.11.55  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWHGBS(WEIGHT,GEN)
C-----------------------------------------------------------------------
C     Multichannel phase space for gauge boson pair production
C     ICH returns the channel used if OPTM=.FALSE.
C     ICH specifies the channel to be used if OPTM=.TRUE.
C     This is used in optimising the weights for the different channels
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      INTEGER ICH,IDBOS,ISM(2,IMAXCH),I,J,IB(2),IDRES,IDP,IOPT,IPRC,ID1
      DOUBLE PRECISION XMASS,PLAB,PRW,PCM,RAND,HWRGEN,BMS2(2),TJAC,PLM,
     &     MJAC(2),TWOPI2,SJAC,STOT,THAT,UHAT,TMIN,TMAX,UMIN,UMAX,PS(2),
     &     ETOT,HWUPCM,PST,HWRUNI,TAU,XJAC,PHI,SINTH,SIG(2),CV,CA,BR(2),
     &     G(IMAXCH),XF,DEM,TN,UN,SN,S1,S2,MB1,MB2,WEIGHT,BRFAC,BRZ(12)
      LOGICAL HWRLOG,GEN
      COMMON /HWBOSN/ XMASS(2),PLAB(5,10),PRW(5,2),PCM(5,10),IDBOS(2),
     &     IDRES,IDP(10),IOPT
      EXTERNAL HWRGEN,HWRLOG,HWUPCM,HWRUNI
      SAVE ISM,IPRC
      PARAMETER(TWOPI2=39.4784176D0)
      DOUBLE PRECISION WI(IMAXCH)
      COMMON /HWPSOM/ WI
      SAVE SIG,BRZ
      DATA SIG/1.0D0,-1.0D0/
      DATA BRZ/0.154D0,0.120D0,0.154D0,0.120D0,0.152D0,0.000D0,
     &         0.033D0,0.067D0,0.033D0,0.067D0,0.033D0,0.067D0/
      IF(IERROR.NE.0) RETURN
      WEIGHT = ZERO
      IF(OPTM) THEN
        DO I=1,IMAXCH
          WI(I) = ZERO
        ENDDO
      ENDIF
      GEN = .FALSE.
C--set the smoothing for the bosons in the various channels
      IF(FSTWGT) THEN
        IPRC = MOD(IPROC,100)
        DO I=1,2
          ISM(1,I) = 1
          DO J=1,2
            ISM(1,4*I-2+J  ) = 1
            ISM(1,4*I+J    ) = 2
            ISM(2,4*I+2*J-3) = 1
            ISM(2,4*I+2*J-2) = 2
          ENDDO
        ENDDO
        ISM(2,1) = 1
        ISM(2,2) = 2
      ENDIF
C--select the channel to be used
      RAND=HWRGEN(0)
      DO ICH=1,IMAXCH
        IF(CHON(ICH)) THEN
          IF(CHNPRB(ICH).GT.RAND) GOTO 10
          RAND = RAND-CHNPRB(ICH)
        ENDIF
      ENDDO
 10   CONTINUE
C--select the boson masses and compute that part of the denominator
C--decide which boson to do first
      IF(HWRLOG(HALF)) THEN
        IB(1) = 1
        IB(2) = 2
      ELSE
        IB(1) = 2
        IB(2) = 1
      ENDIF
C--find the boson masses
      CALL HWHGB1(ISM(IB(1),ICH),2,IDBOS(IB(1)),MJAC(IB(1)),BMS2(IB(1)),
     &     (PHEP(5,3)-EMMIN)**2,EMMIN**2)
      XMASS(IB(1)) = SQRT(BMS2(IB(1)))
      CALL HWHGB1(ISM(IB(2),ICH),2,IDBOS(IB(2)),MJAC(IB(2)),BMS2(IB(2)),
     &     (PHEP(5,3)-XMASS(IB(1)))**2,EMMIN**2)
      XMASS(IB(2)) = SQRT(BMS2(IB(2)))
      DO I=1,2
        MJAC(I) = HALF*MJAC(I)/TWOPI2
      ENDDO
C--now generate the values of s
C--according to a Breit-Wigner for the first two
      IF(ICH.LE.2) THEN
        CALL HWHGB1(1,2,IDRES,SJAC,STOT,PHEP(5,3)**2,
     &        (SQRT(BMS2(1)+PTMIN**2)+SQRT(BMS2(2)+PTMIN**2))**2)
C--according to a power law for the rest
      ELSE
        CALL HWHGB1(2,2,IDRES,SJAC,STOT,PHEP(5,3)**2,
     &        (SQRT(BMS2(1)+PTMIN**2)+SQRT(BMS2(2)+PTMIN**2))**2)
      ENDIF
      ETOT = SQRT(STOT)
C--find the centre of mass momenta
      PST = HWUPCM(ETOT,XMASS(1),XMASS(2))
      IF(PST.LT.PTMIN) RETURN
      PRW(4,1) = SQRT(BMS2(1)+PST**2)
      PRW(4,2) = SQRT(BMS2(2)+PST**2)
C--now generate the value of t and u
      PLM = SQRT(PST**2-PTMIN**2)
      TMIN   = BMS2(1)-ETOT*(PRW(4,1)+PLM)
      TMAX   = BMS2(1)-ETOT*(PRW(4,1)-PLM)
      UMIN   = BMS2(2)-ETOT*(PRW(4,2)+PLM)
      UMAX   = BMS2(2)-ETOT*(PRW(4,2)-PLM)
      SN     = ONE/(TMAX-TMIN)
C--for the first two channels uniform in t
      IF(ICH.LE.2) THEN
        THAT = HWRUNI(1,TMIN,TMAX)
        UHAT = BMS2(1)+BMS2(2)-STOT-THAT
        TJAC = TMAX-TMIN
C--for the next four channels generate t according to 1/t
      ELSEIF(ICH.LE.6) THEN
        CALL HWHGB5(2,TJAC,THAT,TMAX,TMIN)
        UHAT = BMS2(1)+BMS2(2)-STOT-THAT
C--for the last four channels generate u according to 1/u
      ELSEIF(ICH.LE.10) THEN
        CALL HWHGB5(2,TJAC,UHAT,UMAX,UMIN)
        THAT = BMS2(1)+BMS2(2)-STOT-UHAT
      ELSE
        CALL HWWARN('HWHGBS',500)
      ENDIF
      CALL HWHGB5(1,TN,THAT,TMAX,TMIN)
      CALL HWHGB5(1,UN,UHAT,UMAX,UMIN)
C--generate the parton momentum fractions and find the pdf's
      TAU = STOT/PHEP(5,3)**2
      XX(1) = EXP(HWRUNI(3,LOG(TAU),ZERO))
      XX(2) = TAU/XX(1)
      XJAC = -LOG(TAU)*XX(1)
      XF   = ONE/XJAC
      EMSCA=ETOT
      CALL HWSGEN(.FALSE.)
C--Centre of mass collison angle
      COSTH = (THAT-BMS2(1)+ETOT*PRW(4,1))/ETOT/PST
      PHI   = HWRUNI(4,ZERO,TWO*PIFAC)
      SINTH = SQRT(ONE-COSTH**2)
C--incoming momenta in the centre of mass frame
      DO I=1,2
        PLAB(1,I) = ZERO
        PLAB(2,I) = ZERO
        PLAB(3,I) = HALF*ETOT
        PLAB(4,I) = HALF*ETOT
        PLAB(5,I) = ZERO
      ENDDO
      PLAB(3,2) = -PLAB(3,2)
C--outgoing boson momenta in the centre of mass frame
      DO I=1,2
        PRW(1,I) = SIG(I)*SINTH*COS(PHI)*PST
        PRW(2,I) = SIG(I)*SINTH*SIN(PHI)*PST
        PRW(3,I) = SIG(I)*COSTH*PST
        PRW(5,I) = XMASS(I)
      ENDDO
C--now find the boson decay products
C--find the momenta of the boson decay products
      IF(IPRC.EQ.20) IDBOS(1)=198
      DO 90 I=1,2
        CALL HWDBZ2(IDBOS(I),IDP(2*I+1),IDP(2*I+2),CV,CA,BR(I),IOPT,
     &        XMASS(I))
        IF(BR(I).EQ.ZERO) RETURN
        PRW(5,I)=XMASS(I)
        PLAB(5,2*I+1) = ZERO
        PLAB(5,2*I+2) = ZERO
        PS(I) = HALF*XMASS(I)
        PLAB(5,2*I+1)=ZERO
        PLAB(5,2*I+2)=ZERO
        CALL HWDTWO(PRW(1,I),PLAB(1,2*I+1),PLAB(1,2*I+2),
     &              PS(I),TWO,.TRUE.)
 90   CONTINUE
      BRFAC = BR(2)
      IF(IOPT.EQ.0) BRFAC = BRFAC*BR(1)
      DO I=1,2
         IF(IDBOS(I).EQ.200) THEN
            ID1 = IDP(1+2*I)
            IF(ID1.GE.121) ID1 = ID1-114
            BRFAC = BRFAC/BRZ(ID1)
         ENDIF
      ENDDO
      DO I=1,2
        MJAC(I) = MJAC(I)*PS(I)/XMASS(I)
      ENDDO
C--set up a vector with the centre of mass
      PLAB(1,7) = ZERO
      PLAB(2,7) = ZERO
      PLAB(3,7) = HALF*PHEP(5,3)*(XX(1)-XX(2))
      PLAB(4,7) = HALF*PHEP(5,3)*(XX(1)+XX(2))
      PLAB(5,7) = ETOT
C--now find the denominator
      CALL HWHGB1(1,1,IDRES,S1,STOT,PHEP(5,3)**2,
     &     (XMASS(1)+XMASS(2))**2)
      CALL HWHGB1(2,1,IDRES,S2,STOT,PHEP(5,3)**2,
     &        (XMASS(1)+XMASS(2))**2)
      DEM = ZERO
      DO I=1,IMAXCH
        IF(CHON(I)) THEN
C--factors due to the choice of s and t
          IF(I.LE.2) THEN
            G(I) = SN*S1
          ELSEIF(I.LE.6) THEN
            G(I) = TN*S2
          ELSE
            G(I) = UN*S2
          ENDIF
C--factors due to the boson masses
          CALL HWHGB1(ISM(IB(1),I),1,IDBOS(IB(1)),MB1,BMS2(IB(1)),
     &         (PHEP(5,3)-EMMIN)**2,EMMIN**2)
          CALL HWHGB1(ISM(IB(2),I),1,IDBOS(IB(2)),MB2,BMS2(IB(2)),
     &         (PHEP(5,3)-XMASS(IB(1)))**2,EMMIN**2)
          G(I)   = G(I)*MB1*MB2*XF
          DEM = DEM+CHNPRB(I)*G(I)
        ENDIF
      ENDDO
C--now combine everything to get the weight
      WEIGHT = GEV2NB*TJAC*SJAC*G(ICH)/DEM/XX(1)*
     &     MJAC(1)*MJAC(2)*XJAC/64.0D0/PIFAC/STOT**3*BRFAC
      GEN = .TRUE.
C--compute the weights for the different channels if optimizing
      IF(OPTM) THEN
        DO I=1,IMAXCH
          IF(CHON(I)) WI(I)=G(I)*WEIGHT**2/DEM
        ENDDO
      ENDIF
      END
