CDECK  ID>, HWISP4.
*CMZ :-        -12/10/01  12.04.54  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWISP4
C-----------------------------------------------------------------------
C     Initialise the Higgs four body modes
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      INTEGER I,J,K,IL,IH,II,JJ
      DOUBLE PRECISION COL(2),SW,CW,TW,E,G,RT,ORT,MW,MZ,AFN(2,12,2,4),
     &     AFG(2,6,2),AFC(2,12,2,2),OIJ(2,4,2),OIJP(2,2,2),OIJPP(2,4,4),
     &     HNN(2,3,4,4),HCC(2,3,2,2),HNC(2,4,2),HFF(2,4,12),HWW(2),
     &     HZZ(2),ZAB(12,2,2),HHB(2,3),GS
      COMMON /HWSPNC/ SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN,AFG,AFC,OIJ,OIJP,
     &               OIJPP,HNN,HCC,HNC,HFF,HWW,HZZ,ZAB,HHB
      IF(IERROR.NE.0.OR..NOT.SUSYIN) RETURN
C--four body Higgs modes via virtual WW and ZZ
      DO 1000 JJ=1,NRES
      DO 1000 II=1,NMODES(JJ)
        IF(II.EQ.1) THEN
          I = LSTRT(JJ)
        ELSE
          I = LNEXT(I)
        ENDIF
        IH=IDK(I)-202
        IF((IH.EQ.1.OR.IH.EQ.2).AND.IDKPRD(3,I).EQ.0.AND.
     &       IDKPRD(1,I).GE.198.AND.IDKPRD(1,I).LE.200.AND.
     &       IDKPRD(2,I).GE.198.AND.IDKPRD(2,I).LE.200) THEN
C--first the WW modes
          IF(IDKPRD(1,I).NE.200) THEN
            N4MODE = N4MODE+1
            IF(N4MODE.GT.NMODE4) THEN
              CALL HWWARN('HWISP4',100)
              GOTO 999
            ENDIF
            NME(I) = 40000+N4MODE
            ID4PRT(N4MODE) = I
            I4MODE(1,N4MODE) = 198
            I4MODE(2,N4MODE) = 199
            DO 1 K=1,6
            A4MODE(1,K,N4MODE) = ZERO
            A4MODE(2,K,N4MODE) =-G*ORT
            B4MODE(1,K,N4MODE) = ZERO
 1          B4MODE(2,K,N4MODE) =-G*ORT
C--now the prefactors
            DO 2 J=1,6
            COL(1) = HWW(IH)**2
            IF(J.LE.3) COL(1) = THREE*COL(1)
            DO 2 K=1,6
            COL(2) = ONE
            IF(K.LE.3) COL(2) = THREE*COL(2)
 2          P4MODE(J,K,N4MODE) = COL(1)*COL(2)
C--then the ZZ modes
          ELSE
            N4MODE = N4MODE+1
            IF(N4MODE.GT.NMODE4) THEN
              CALL HWWARN('HWISP4',101)
              GOTO 999
            ENDIF
            NME(I) = 40000+N4MODE
            ID4PRT(N4MODE) = I
            I4MODE(1,N4MODE) = 200
            I4MODE(2,N4MODE) = 200
            DO 3 K=1,12
            IL = K
            IF(K.GT.6) IL=K+4
            A4MODE(1,K,N4MODE) =-E*RFCH(IL)
            A4MODE(2,K,N4MODE) =-E*LFCH(IL)
            B4MODE(1,K,N4MODE) =-E*RFCH(IL)
 3          B4MODE(2,K,N4MODE) =-E*LFCH(IL)
            DO 4 J=1,12
            COL(1) = HALF*HZZ(IH)**2
            IF(J.LE.6) COL(1)=THREE*COL(1)
            DO 4 K=1,12
            COL(2) = ONE
            IF(K.LE.6) COL(2) = THREE
 4          P4MODE(J,K,N4MODE) = COL(1)*COL(2)
          ENDIF
        ENDIF
 1000 CONTINUE
C--compute the maximum weights
      IF(N4MODE.EQ.0) RETURN
      DO 2000 I=1,N4MODE
      PHEP(5,1) = RMASS(IDK(ID4PRT(I)))
      PHEP(4,1) = SQRT(100.0D0**2+PHEP(5,1)**2)
      PHEP(1,1) = 100.0D0
      PHEP(2,1) = 0.0D0
      PHEP(3,1) = 0.0D0
      IF(IPRINT.GE.2) WRITE(6,5010) RNAME(IDK(ID4PRT(I))),
     &            RNAME(IDKPRD(1,ID4PRT(I))),RNAME(IDKPRD(2,ID4PRT(I)))
      IL = 12
      IF(I4MODE(1,I).NE.200) IL = 6
      DO 2000 J=1,IL
      DO 2000 K=1,IL
 2000 CALL HWD4ME(1,J,K,I)
      RETURN
 5010 FORMAT(/'CALCULATING TWO BODY DECAY ',
     &     A8,' --> ',A8,' ',A8/)
 999  RETURN
      END
