CDECK  ID>, HWISPC.
*CMZ :-        -27/07/99  16.38.25  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWISPC
C-----------------------------------------------------------------------
C     Calculates the couplings for the SUSY decays for spin correlations
C     and 3/4 body matrix elements
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      DOUBLE PRECISION HWUALF,PRE,MCHAR(2),QIJPP(4,4),SIJPP(4,4),
     &     DIJ(2,2),QIJ(2,2),R(4,2),SIJ(2,2)
      INTEGER I,J,K,L,IH,IK,IL,IQ
      COMMON /HWSPNC/ SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN,AFG,AFC,OIJ,OIJP,
     &               OIJPP,HNN,HCC,HNC,HFF,HWW,HZZ,ZAB,HHB
      DOUBLE PRECISION SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN(2,12,2,4),
     &     AFG(2,6,2),AFC(2,12,2,2),OIJ(2,4,2),OIJP(2,2,2),OIJPP(2,4,4),
     &     HNN(2,3,4,4),HCC(2,3,2,2),HNC(2,4,2),HFF(2,4,12),HWW(2),
     &     HZZ(2),ZAB(12,2,2),HHB(2,3)
      EXTERNAL HWUALF
      SAVE DIJ
      DATA DIJ/1.0D0,0.0D0,0.0D0,1.0D0/
      IF(IERROR.NE.0) RETURN
C--coupling constants
      SW  = SQRT(SWEIN)
      CW  = SQRT(ONE-SWEIN)
      TW  = SW/CW
      E   = SQRT(FOUR*PIFAC/128.0D0)
      G   = E/SW
      RT  = SQRT(TWO)
      ORT = ONE/RT
      MW  = RMASS(198)
      MZ  = RMASS(200)
      IF(.NOT.SUSYIN) RETURN
      GS  = SQRT(HWUALF(3,RMASS(449))*FOUR*PIFAC)
C--couplings of the neutralinos to the squarks
      DO 1 L=1,4
      MCHAR(1) = ORT*G*ZMIXSS(L,3)/MW/COSB
      MCHAR(2) = ORT*G*ZMIXSS(L,4)/MW/SINB
      DO 1 I=1,3
      J = 2*I-1
      DO 2 K=1,2
      AFN(1,J,K,L) =-MCHAR(1)*RMASS(J)*QMIXSS(J,2,K)
     &                    -RT*E*QMIXSS(J,1,K)*SLFCH(J,L)
 2    AFN(2,J,K,L) =-ZSGNSS(L)*(MCHAR(1)*RMASS(J)*QMIXSS(J,1,K)
     &                          +RT*E*QMIXSS(J,2,K)*SRFCH(J,L))
      J = 2*I
      DO 1 K=1,2
      AFN(1,J,K,L) =-MCHAR(2)*RMASS(J)*QMIXSS(J,2,K)
     &                       -RT*E*QMIXSS(J,1,K)*SLFCH(J,L)
 1    AFN(2,J,K,L) =-ZSGNSS(L)*(MCHAR(2)*RMASS(J)*QMIXSS(J,1,K)
     &                        +RT*E*QMIXSS(J,2,K)*SRFCH(J,L))
C--couplings of the neutralinos to the sleptons
      DO 3 L=1,4
      MCHAR(1) = ORT*G*ZMIXSS(L,3)/MW/COSB
      DO 3 I=1,3
      J = 2*I-1
      IL = J+10
      IK = J+6
      DO 4 K=1,2
      AFN(1,IK,K,L) =-(MCHAR(1)*RMASS(110+IL)*LMIXSS(J,2,K)
     &                        +RT*E*LMIXSS(J,1,K)*SLFCH(IL,L))
 4    AFN(2,IK,K,L) =-ZSGNSS(L)*(MCHAR(1)*RMASS(110+IL)*LMIXSS(J,1,K)
     &                            +RT*E*LMIXSS(J,2,K)*SRFCH(IL,L))
      J = J+1
      IL = IL+1
      IK = IK+1
      DO 3 K=1,2
      AFN(1,IK,K,L) =-RT*E*LMIXSS(J,1,K)*SLFCH(IL,L)
 3    AFN(2,IK,K,L) = ZERO
C--couplings of the gluinos to the squarks
      DO 5 I=1,6
      DO 5 K=1,2
      AFG(1,I,K) = -GS*RT*QMIXSS(I,1,K)
 5    AFG(2,I,K) = +GS*RT*QMIXSS(I,2,K)
C--couplings of the charginos to the squarks
      DO 6 L=1,2
      MCHAR(1) =-WMXVSS(L,2)*ORT/MW/SINB
      MCHAR(2) =-WMXUSS(L,2)*ORT/MW/COSB
      DO 6 I=1,3
      J = 2*I-1
      DO 7 K=1,2
      AFC(1,J,K,L) = -G*( WMXUSS(L,1)*QMIXSS(J,1,K)
     &                   +MCHAR(2)*RMASS(J)*QMIXSS(J,2,K))
 7    AFC(2,J,K,L) = -G*WSGNSS(L)*MCHAR(1)*
     &              RMASS(J+1)*QMIXSS(J,1,K)
      J = 2*I
      DO 6 K=1,2
      AFC(1,J,K,L) = -G*WSGNSS(L)*( WMXVSS(L,1)*QMIXSS(J,1,K)
     &                           +MCHAR(1)*RMASS(J)*QMIXSS(J,2,K))
 6    AFC(2,J,K,L) = -G*MCHAR(2)*RMASS(J-1)*QMIXSS(J,1,K)
C--couplings of the charginos to the sleptons
      DO 8 L=1,2
      MCHAR(1) = -WMXUSS(L,2)*ORT/MW/COSB
      DO 8 I=1,3
      J = 2*I-1
      IL = J+6
      DO 9 K=1,2
      AFC(1,IL,K,L) = -G*(WMXUSS(L,1)*LMIXSS(J,1,K)
     &                +RMASS(120+J)*MCHAR(1)*LMIXSS(J,2,K))
 9    AFC(2,IL,K,L) = ZERO
      J = J+1
      IL = IL+1
      DO 8 K=1,2
      AFC(1,IL,K,L) =-WSGNSS(L)*G*WMXVSS(L,1)
 8    AFC(2,IL,K,L) =-MCHAR(1)*G*RMASS(119+J)
C--couplings of chargino-neutralino to the W
      DO 10 I=1,4
      DO 10 J=1,2
      OIJ(1,I,J) = G*( ORT*ZMXNSS(I,3)*WMXUSS(J,2)
     &                    +ZMXNSS(I,2)*WMXUSS(J,1))
 10   OIJ(2,I,J) = ZSGNSS(I)*WSGNSS(J)*G*(-ORT*ZMXNSS(I,4)*WMXVSS(J,2)
     &                                        +ZMXNSS(I,2)*WMXVSS(J,1))
C--couplings of chargino-chargino to the Z
      PRE = G/CW
      DO 11 I=1,2
      DO 11 J=1,2
      OIJP(1,I,J) = PRE*(-WMXUSS(I,1)*WMXUSS(J,1)
     &             -HALF*WMXUSS(I,2)*WMXUSS(J,2)+DIJ(I,J)*SWEIN)
 11   OIJP(2,I,J) = WSGNSS(I)*WSGNSS(J)*PRE*(-WMXVSS(I,1)*WMXVSS(J,1)
     &             -HALF*WMXVSS(I,2)*WMXVSS(J,2)+DIJ(I,J)*SWEIN)
C--couplings of neutralino-neutralino to the Z
      PRE = HALF*G/CW
      DO 12 I=1,4
      DO 12 J=1,4
      OIJPP(1,I,J) = PRE*(ZMIXSS(I,3)*ZMIXSS(J,3)
     &                           -ZMIXSS(I,4)*ZMIXSS(J,4))
 12   OIJPP(2,I,J) = -ZSGNSS(I)*ZSGNSS(J)*OIJPP(1,I,J)
C--couplings of the neutralino-neutralino to the Higgs
      DO 13 I=1,4
      DO 13 J=1,4
      QIJPP(I,J) = HALF*ZSGNSS(I)*
     &                      (ZMXNSS(I,3)*(ZMXNSS(J,2)-ZMXNSS(J,1)*TW)
     &                      +ZMXNSS(J,3)*(ZMXNSS(I,2)-ZMXNSS(I,1)*TW))
 13   SIJPP(I,J) = HALF*ZSGNSS(I)*
     &                      (ZMXNSS(I,4)*(ZMXNSS(J,2)-ZMXNSS(J,1)*TW)
     &                      +ZMXNSS(J,4)*(ZMXNSS(I,2)-ZMXNSS(I,1)*TW))
      DO 14 I=1,4
      DO 14 J=1,4
      HNN(1,1,I,J) = G*(QIJPP(I,J)*SINA+SIJPP(I,J)*COSA)
      HNN(2,1,I,J) = G*(QIJPP(J,I)*SINA+SIJPP(J,I)*COSA)
      HNN(1,2,I,J) = G*(SIJPP(I,J)*SINA-QIJPP(I,J)*COSA)
      HNN(2,2,I,J) = G*(SIJPP(J,I)*SINA-QIJPP(J,I)*COSA)
      HNN(1,3,I,J) = G*(QIJPP(I,J)*SINB-SIJPP(I,J)*COSB)
 14   HNN(2,3,I,J) =-G*(QIJPP(J,I)*SINB-SIJPP(J,I)*COSB)
C--couplings of chargino-chargino to the Higgs
      DO 15 I=1,2
      DO 15 J=1,2
      QIJ(I,J) = ORT*WSGNSS(I)*WMXVSS(I,1)*WMXUSS(J,2)
 15   SIJ(I,J) = ORT*WSGNSS(I)*WMXVSS(I,2)*WMXUSS(J,1)
      DO 16 I=1,2
      DO 16 J=1,2
      HCC(1,1,I,J) = G*(QIJ(I,J)*SINA-SIJ(I,J)*COSA)
      HCC(2,1,I,J) = G*(QIJ(J,I)*SINA-SIJ(J,I)*COSA)
      HCC(1,2,I,J) =-G*(QIJ(I,J)*COSA+SIJ(I,J)*SINA)
      HCC(2,2,I,J) =-G*(QIJ(J,I)*COSA+SIJ(J,I)*SINA)
      HCC(1,3,I,J) = G*(QIJ(I,J)*SINB+SIJ(I,J)*COSB)
 16   HCC(2,3,I,J) =-G*(QIJ(J,I)*SINB+SIJ(J,I)*COSB)
C--couplings of chargino-neutralino to the Higgs
      DO 17 I=1,4
      DO 17 J=1,2
      HNC(1,I,J) =-G*ZSGNSS(I)*SINB*(ZMXNSS(I,3)*WMXUSS(J,1)
     &            -ORT*(ZMXNSS(I,2)+ZMXNSS(I,1)*TW)*WMXUSS(J,2))
 17   HNC(2,I,J) =-G*WSGNSS(J)*COSB*(ZMXNSS(I,4)*WMXVSS(J,1)
     &            +ORT*(ZMXNSS(I,2)+ZMXNSS(I,1)*TW)*WMXVSS(J,2))
C--fermion couplings to the Higgs
      R(1,1) = HALF*G*SINA/MW/COSB
      R(1,2) =-HALF*G*COSA/MW/SINB
      R(2,1) =-HALF*G*COSA/MW/COSB
      R(2,2) =-HALF*G*SINA/MW/SINB
      R(3,1) = HALF*G*TANB/MW
      R(3,2) = HALF*G*COTB/MW
      R(4,1) = G*ORT*TANB/MW
      R(4,2) = G*ORT*COTB/MW
      DO 18 I=1,3
      J = 2*I-1
      K = 2*I
      IL = J+6
      IQ = K+6
      DO 19 IK=1,3
      DO 19 L=1,2
      HFF(L,IK,J ) = R(IK,1)*RMASS(J)
      HFF(L,IK,K ) = R(IK,2)*RMASS(K)
      HFF(L,IK,IL) = R(IK,1)*RMASS(114+IL)
 19   HFF(L,IK,IQ) = ZERO
      HFF(2,3,J )  = -HFF(2,3, J)
      HFF(2,3,K )  = -HFF(2,3, K)
      HFF(2,3,IL)  = -HFF(2,3,IL)
      HFF(1,4,I)   = RMASS(J)*R(4,1)
      HFF(2,4,I)   = RMASS(K)*R(4,2)
      HFF(1,4,I+3) = RMASS(114+IL)*R(4,1)
 18   HFF(2,4,I+3) = ZERO
C--couplings of the Higgs to gauge boson pairs
      HWW(1) = G*MW*SINBMA
      HWW(2) = G*MW*COSBMA
      HZZ(1) = G*MZ*SINBMA/CW
      HZZ(2) = G*MZ*COSBMA/CW
C--couplings of the Z to the sfermions
      DO 20 I=1,3
      IQ = 2*I-1
      IL = 2*I
      IK = 2*I+5
      IH = 2*I+6
      DO 20 J=1,2
      DO 20 K=1,2
      ZAB(IQ,J,K) = G/CW*HALF*( QMIXSS(IQ,1,J)*QMIXSS(IQ,1,K)
     &                         -TWO*DIJ(J,K) *SWEIN/THREE)
      ZAB(IL,J,K) = G/CW*HALF*(-QMIXSS(IL,1,J)*QMIXSS(IL,1,K)
     &                         -FOUR*DIJ(J,K)*SWEIN/THREE)
      ZAB(IK,J,K) = G/CW*HALF*( LMIXSS(IQ,1,J)*LMIXSS(IQ,1,K)
     &                         -TWO*DIJ(J,K)*SWEIN)
 20   ZAB(IH,J,K) =-G/CW*HALF*DIJ(J,1)*DIJ(K,1)
C--couplings of the Higgs Higgs to the gauge bosons
      HHB(1,1) = HALF*G*COSBMA
      HHB(1,2) = HALF*G*SINBMA
      HHB(1,3) = HALF*G
      HHB(2,1) =-HALF*G*COSBMA/CW
      HHB(2,2) = HALF*G*SINBMA/CW
      HHB(2,3) = ZERO
      END
